/* sf33r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__33 = 33;

/* Subroutine */ int sf33r_c(real *x, integer *n, integer *nmax, real *fun1,
        real *fun2, real *work, integer *ierr)
{
    /* Initialized data */

    static real sys039 = .577215665f;
    static real sys015 = .63661977f;
    static real sys005 = 1.57079633f;

    /* System generated locals */
    integer i__1, i__2;
    real r__1;

    /* Builtin functions */
    double log(doublereal), sqrt(doublereal), sin(doublereal),
            cos(doublereal);

    /* Local variables */
    static integer i__, j, k;
    static real p, r__, u, v;
    extern /* Subroutine */ int utsf10_c(integer *, integer *);
    static integer n1, n2;
    static real p0, p1, q0, q1, q2, r1, r2, r3, r4, r5, u1, u2, u3, u4, u5, 
            v1, v2, v3, v4, v5, v6, v7;
    static integer na, nb, nc1, nc2;

    /* Parameter adjustments */
    --work;
    --fun2;
    --fun1;

    /* Function Body */
    if (*n < 2) {
        goto L26;
    }
/* Computing MAX */
    i__1 = *n, i__2 = ((integer) (*x) << 1) + 4;
    nc1 = max(i__1,i__2);
    if (*nmax < nc1) {
        goto L28;
    }
    *ierr = 0;
    if (*x <= 0.f) {
        goto L1;
    } else {
        goto L2;
    }
L1:
    *ierr = 67;
    goto L27;
L2:
/* Computing MAX */
    r__1 = *x + 1.f;
    nc1 = (integer) max(r__1,3.f);
    nc2 = (nc1 << 1) + 1;
    if (*n - nc1 <= 0) {
        goto L3;
    } else {
        goto L4;
    }
L3:
    n2 = *n;
    n1 = *n;
    goto L7;
L4:
    n1 = nc1;
    if (*n - nc2 <= 0) {
        goto L5;
    } else {
        goto L6;
    }
L5:
    n2 = nc2 + 1;
    goto L7;
L6:
    n2 = *n;
L7:
    if (*x >= 10.f) {
        goto L14;
    }
    if (*x > 1.f) {
        goto L12;
    }
    r1 = *x * .5f;
/* Computing 2nd power */
    r__1 = r1;
    r2 = -(r__1 * r__1);
    u1 = 1.f;
    u2 = 1.f;
    u3 = 1.f;
    u4 = 1.f;
    p0 = 1.f;
    p1 = 1.f;
    q0 = -((real)log(r1) + sys039);
    v1 = q0;
    q1 = v1 + .5f;
    v2 = q1;
    for (i__ = 1; i__ <= 8; ++i__) {
        u1 = u1 * r2 / (real) ((*n - 1 + i__) * i__);
        p0 += u1;
        u2 = u2 * r2 / (real) ((*n - 2 + i__) * i__);
        p1 += u2;
        r3 = 1.f / (real) i__;
        r4 = 1.f / (real) (i__ + 1);
/* Computing 2nd power */
        r__1 = r3;
        u3 = u3 * r2 * (r__1 * r__1);
        v1 += r3;
        q0 += u3 * v1;
        u4 = u4 * r2 * r3 * r4;
        v2 += (r3 + r4) * .5f;
        q1 += u4 * v2;
/* L8: */
    }
    fun1[*n] = p0;
    fun1[*n - 1] = p1;
    r3 = -sys015;
    fun2[1] = r3 * q0;
    fun2[2] = r3 * (1.f - r2 * 2.f * q1);
    if (*n == 2) {
        goto L11;
    }
    fun2[3] = fun2[2] + r2 * fun2[1] * 2;
    i__1 = *n;
    for (i__ = 4; i__ <= i__1; ++i__) {
        fun2[i__] = fun2[i__ - 1] + fun2[i__ - 2] * r2 /
                (real) ((i__ - 2) * (i__ - 3));
/* L9: */
    }
    na = *n - 2;
    i__1 = na;
    for (j = 1; j <= i__1; ++j) {
        i__ = na - j + 1;
        fun1[i__] = fun1[i__ + 1] + fun1[i__ + 2] * r2 /
                (real) (i__ * (i__ + 1));
/* L10: */
    }
L11:
    goto L25;
L12:
    r1 = *x * .5f;
/* Computing 2nd power */
    r__1 = r1;
    r2 = -(r__1 * r__1);
    u1 = 1.f;
    u2 = 1.f;
    p0 = 1.f;
    p1 = 1.f;
    q0 = -((real)log(r1) + sys039);
    v1 = q0;
    q1 = v1 + .5f;
    v2 = q1;
    for (i__ = 1; i__ <= 20; ++i__) {
        r3 = 1.f / (real) i__;
        r4 = 1.f / (real) (i__ + 1);
/* Computing 2nd power */
        r__1 = r3;
        u1 = u1 * r2 * (r__1 * r__1);
        p0 += u1;
        v1 += r3;
        q0 += u1 * v1;
        u2 = u2 * r2 * r3 * r4;
        p1 += u2;
        v2 += (r3 + r4) * .5f;
        q1 += u2 * v2;
/* L13: */
    }
    fun1[1] = p0;
    fun1[2] = r1 * p1;
    r2 = -sys015;
    fun2[1] = r2 * q0;
    fun2[2] = (.5f / r1 + r1 * q1) * r2;
    goto L16;
L14:
    r1 = .125f / *x;
/* Computing 2nd power */
    r__1 = r1;
    r2 = -(r__1 * r__1);
    p0 = 1.f;
    q0 = 1.f;
    p1 = 1.f;
    q1 = 1.f;
    u1 = 1.f;
    u2 = 1.f;
    u3 = 1.f;
    u4 = 1.f;
    for (i__ = 1; i__ <= 9; ++i__) {
        v1 = (real) (i__ << 1);
        v2 = v1 * 2.f;
/* Computing 2nd power */
        r__1 = (v2 - 3.f) * (v2 - 1.f);
        v3 = r__1 * r__1;
/* Computing 2nd power */
        r__1 = v2;
        v4 = r__1 * r__1 - 1.f;
        v5 = v4 * (v2 - 3.f);
        v6 = v5 * (v2 + 3.f);
        v5 *= v2 - 5.f;
/* Computing 2nd power */
        r__1 = v4;
        v4 = r__1 * r__1;
        v7 = r2 / ((v1 - 1.f) * v1);
        v2 = r2 / ((v1 + 1.f) * v1);
        u1 = u1 * v3 * v7;
        p0 += u1;
        u2 = u2 * v4 * v2;
        q0 += u2;
        u3 = u3 * v5 * v7;
        p1 += u3;
        u4 = u4 * v6 * v2;
        q1 += u4;
/* L15: */
    }
    q0 = r1 * q0;
    q1 = r1 * 3.f * q1;
    u1 = sys005;
    u2 = (real)sqrt((real)(u1 * *x));
    u3 = *x + u1 * .5f;
    u4 = (real)sin(u3) / u2;
    u5 = (real)cos(u3) / u2;
    fun1[1] = p0 * u4 - q0 * u5;
    fun1[2] = q1 * u4 - p1 * u5;
    fun2[1] = -(p0 * u5 + q0 * u4);
    fun2[2] = -(p1 * u4 + q1 * u5);
L16:
    r1 = 2.f / *x;
    i__1 = n1;
    for (i__ = 3; i__ <= i__1; ++i__) {
        r2 = r1 * (real) (i__ - 2);
        fun1[i__] = r2 * fun1[i__ - 1] - fun1[i__ - 2];
        fun2[i__] = r2 * fun2[i__ - 1] - fun2[i__ - 2];
/* L17: */
    }
    if (n1 == *n) {
        goto L25;
    }
    r1 = *x * .5f;
/* Computing 2nd power */
    r__1 = r1;
    r2 = r__1 * r__1;
    q2 = 1.f;
    u = 1.f;
    v = 1.f;
    r3 = r1;
    na = n2 - 2;
    i__1 = na;
    for (i__ = 1; i__ <= i__1; ++i__) {
        v += 1.f / (real) (i__ + 1);
        u = u * r2 / (real) (i__ * (na + 1 - i__));
        q2 += u;
        r3 = r3 * r1 / (real) i__;
/* L18: */
    }
    u = 1.f;
    p = 1.f;
    r2 = -r2;
    if (*x - 10.f >= 0.f) {
        goto L20;
    } else {
        goto L19;
    }
L19:
    k = 20;
    goto L21;
L20:
    k = nc2 - 1;
L21:
    q1 = v * .5f - (real)log(r1) - sys039;
    i__1 = k;
    for (i__ = 1; i__ <= i__1; ++i__) {
        r4 = 1.f / (real) i__;
        r5 = 1.f / (real) (n2 - 1 + i__);
        u = u * r2 * r4 * r5;
        p += u;
        v += (r4 + r5) * .5f;
        q1 += u * v;
/* L22: */
    }
    q2 = q2 * .5f / r3;
    r3 /= (real) (n2 - 1);
    p *= r3;
    q1 *= r3;
    r2 = -sys015;
    fun1[n2] = p;
    fun2[n2] = r2 * (q1 + q2);
    r__ = 2.f / *x;
    work[n1] = 0.f;
    na = n1 + 1;
    nb = n2 - 1;
    i__1 = nb;
    for (i__ = na; i__ <= i__1; ++i__) {
        work[i__] = 1.f / (r__ * (real) (i__ - 1) - work[i__ - 1]);
        fun1[i__] = work[i__] * fun1[i__ - 1];
        fun2[i__] = work[i__] * fun2[i__ - 1];
/* L23: */
    }
    i__1 = nb;
    for (j = na; j <= i__1; ++j) {
        i__ = na + nb - j;
        fun1[i__] = work[i__] * fun1[i__ + 1] + fun1[i__];
        fun2[i__] = work[i__] * fun2[i__ + 1] + fun2[i__];
/* L24: */
    }
L25:
    return 0;
L26:
    *ierr = 65;
L27:
    utsf10_c(ierr, &c__33);
    goto L25;
L28:
    *ierr = 66;
    goto L27;
} /* sf33r_c */
